<template>
  <div class="has-bbox-tooltip display-inline-block menu" @click.stop="changeShowMenu">
        <transition name="fade">
            <bbox-icon class="icon" v-show="mobile? mobile:visible"><icon-more-vertical class="font-size-huge ink-lighter-1"></icon-more-vertical></bbox-icon>
        </transition>
        <transition name="fade" @enter="enterTransition">
            <div class="bbox-tooltip display-flex justify-content-center align-content-center margin-top-tiny" :class="[position]" v-show="showMenu && visible" >
                <Card :elevation="4" class="bbox-tooltip-banner border border-white-darker-4 padding-top-tiny padding-bottom-tiny">
                    <ul class="margin-0 padding-0">
                        <li v-for="(option, index) in options" :key="index" style="list-style-type:none;" class="padding-top-tiny padding-bottom-tiny bg-hover-white-darker-3">
                            <p class="margin-0 bbox-tooltip-banner-text display-flex font-size-big padding-left-normal padding-right-normal" :class="option.color?option.color:'ink-lighter-1'" @click.stop=option.method(option.params)><bbox-icon class="margin-right-tiny"><component :is="option.icon" style="height: 100%; margin-top: -2px;"></component></bbox-icon>{{ option.text }}</p>
                        </li>
                    </ul>
                    
                </Card> 
            </div>
        </transition>
  </div>    


</template>

<script>
import BboxIcon from './Icon.vue';
import Card from './Card.vue';

export default {
    props: {
        visible: {
            type: Boolean,
            default: true,
        },
        /* Formato do Array options
        [
            {icon:'icon-create', text:'Editar', color: 'ink-lighter-1', method:edit, params: product}, 
            {icon:'icon-delete', text:'Desativar', color: 'red-base', method:edit, params: product}
        ] 
        */
        options:Array,
        position: {
            type: String,
            default: 'bottom'
        }
    },
    data() {
        return {
            showMenu: false
        }
    },
    components: {
        BboxIcon,
        Card
    },
    watch: {
        visible() {
            if(!this.visible) this.showMenu = false;
        }
    },
    computed: {
        mobile() {
            return window.innerWidth<1024? true : false;
        }
    },
    methods: {
        changeShowMenu() {
            this.showMenu = !this.showMenu;
        },
        changePosition: function(position) {
            this.position = position;
        },
        enterTransition: function(el) {
            var windowOffsetRight = window.innerWidth - el.closest(".has-bbox-tooltip").getBoundingClientRect().right;
            var windowOffsetLeft = el.closest(".has-bbox-tooltip").getBoundingClientRect().left;
            var windowOffsetBottom = window.innerHeight - el.closest(".has-bbox-tooltip").getBoundingClientRect().top;
            var menuWidth = el.children[0].offsetWidth;
            if(windowOffsetLeft < menuWidth) {
                if(windowOffsetBottom >= menuWidth) {
                    this.changePosition('bottom');
                    el.classList.remove('top', 'left', 'right');
                    el.classList.add('bottom');
                    return;
                } else {
                    this.changePosition('right');
                    el.classList.remove('bottom', 'top', 'left');
                    el.classList.add('top');
                    return;
                }
            } else if(windowOffsetRight < menuWidth) {
                if(windowOffsetBottom >= menuWidth) {
                    this.changePosition('left');
                    el.classList.remove('top', 'bottom', 'right');
                    el.classList.add('left');
                    return;
                } else {
                    this.changePosition('top');
                    el.classList.remove('bottom', 'left', 'right');
                    el.classList.add('top');
                    return;
                }
            } 
            
        }
    }  
}
</script>

<style scoped lang="scss">
    ul li p {
        white-space: nowrap;
    }
</style>

<style>
    .has-bbox-tooltip {
        position: relative;
    }
    .bbox-tooltip {
        position: absolute;
        z-index: 2;
        width: fit-content;
        justify-items: center;
        align-items: center; 
    }
    .bbox-tooltip.top {
        transform: translate(calc(-100% + 2.625rem), calc(-100% - 2.625rem - 0.8rem));
        margin: 0;
    }
    .bbox-tooltip.right {
        transform: translate(0%, calc(-100% - 2.625rem - 0.8rem));
        margin: 0;
    }
    .bbox-tooltip.bottom {
        margin-top: 0.8rem;
    }
    .bbox-tooltip.left {
        transform: translate(calc(-100% + 2.625rem), 0);
        margin-top: 0.8rem;
    }
    .bbox-tooltip-banner {
        max-width:27rem;
        box-shadow: 0px 4px 5px 0 rgba(0, 0, 0, 0.14);
    }

    .fade-enter{
        opacity: 0;
    }
    .fade-enter-active{
        transition: opacity .1s;
    }
    .fade-leave{
        /* opacity: 1; */
    }
    .fade-leave-active{
        transition: opacity .1s;
        opacity: 0;
    }
</style>

<docs>

#### HoveringMenu
Este componente é utilizado para exibir um menu de contexto flutuante.

```js

<hovering-menu :visible="true" :options="[
    {icon: 'icon-edit', text: 'Editar', method: editMethod, params: param},
    {icon: 'icon-delete', color: 'red-base', text: 'Deletar', method: deleteMethod, params: param}
]"></hovering-menu>

```

</docs>